From b8862380be9078bea0f62d02a883b11690784f98 Mon Sep 17 00:00:00 2001
From: Anton Mitrofanov <BugMaster@narod.ru>
Date: Mon, 22 Apr 2019 21:41:43 +0300
Subject: [PATCH] Fix integer overflow detected by UBSan in --weightp analysis

Bug report by Xuezhi Yan.
---
 encoder/slicetype.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

diff --git a/encoder/slicetype.c b/encoder/slicetype.c
index 18885e79..a520f586 100644
--- a/encoder/slicetype.c
+++ b/encoder/slicetype.c
@@ -405,8 +405,7 @@ void x264_weights_analyse( x264_t *h, x264_frame_t *fenc, x264_frame_t *ref, int
                  * because scale has a much wider range than offset (because of denom), so
                  * it should almost never need to be clamped. */
                 cur_offset = x264_clip3( cur_offset, -128, 127 );
-                cur_scale = (1 << mindenom) * (fenc_mean[plane] - cur_offset) / ref_mean[plane] + 0.5f;
-                cur_scale = x264_clip3( cur_scale, 0, 127 );
+                cur_scale = x264_clip3f( (1 << mindenom) * (fenc_mean[plane] - cur_offset) / ref_mean[plane] + 0.5f, 0, 127 );
             }
             int start_offset = x264_clip3( cur_offset - offset_dist, -128, 127 );
             int end_offset   = x264_clip3( cur_offset + offset_dist, -128, 127 );
-- 
2.13.0.windows.1

